<?php
/*
 *Plugin Name: SmilePayC2C(UN-PAY)
 *Description: SmilePay 7-11 c2c Shipping
 * Version: 2.4.5
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
*/
 
/**
 * Check if WooCommerce is active
 */
if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
    add_action('plugins_loaded', 'smilepayc2cu_shipping_method_init', 0);
	function  smilepayc2cu_shipping_method_init() {
		if ( ! class_exists( 'WC_Smilepayc2cu_Shipping_Method' ) ) {
			class WC_Smilepayc2cu_Shipping_Method extends WC_Shipping_Method {
           
				public function __construct() {
					$this->id                 = 'smilepay_711_c2c_Shippingunpay';
					$this->method_title       = __( 'SmilePay 7-11 Shipping(UN-PAY)' ); 
					$this->enabled            = "yes";
					$this->title              = u2bcu("SmilePay 7-11Wӯ¨f"); 
 
					$this->init();
				}

				public function init_form_fields() {  //x]m
					
					$this->form_fields = array(
						'enabled' => array(
							'title' => __(u2bcu("ҥ/"), 'woocommerce'),
							'type' => 'checkbox',
							'default' => 'yes',
              'label' => __(u2bcu("SmilePay tRtWӯ¨f"), 'woocommerce'),
						),
						'fee' => array(
							'title'       => __(u2bcu('O'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __( '', 'woocommerce' ),
							'default'     => '',
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),
						'fee_top' => array(
							'title'       => __(u2bcu('KBOe'), 'woocommerce' ),
							'type'        => 'price',
							'description' => __(u2bcu("F즹BɡAKBOAϥνЫOť"), 'woocommerce'),
							'desc_tip'    => true,
							'placeholder' => wc_format_localized_price( 0 )
						),						
						'hiddtext' => array(
							'title' => __(u2bcu('Wӯ¨f`Nƶ'), 'woocommerce'),
							'type' => 'hidden',
							'description' => __(u2bcu("ϥζWӯ¨f\Aݪ`NHUƶG
														<br><font color='red'>ҲնȤ䴩SmilePaytRtyڨϥ</font>							
														<br>1.ХSmilePayӮax}Ҩf\*<a target='_blank' href='http://www.smilepay.net/RVG.ASP'>Ӯax</a>*
														<br>2.bT<font color='red'>pq</font><font color='red'>X</font>Aӫ~ɷ|H²TqC
														<br>3.O̦߭qAiSmilePayӮaxo<font color='red'>fKNX</font>C
														<br>4.O̦߭qAiܭqƵI<font color='red'>}úO</font>C														
														<br>5.бN<font color='red'>fKNX</font>ʷsWܰӫ~ƵAHQO̬dߪyAC
														<br>6.hаѾ\A<font color='red'>SmilePay</font>P<font color='red'>WooCommerceҲջ</font>C
														"), 'woocommerce'),
							'default' => __('', 'woocommerce')
						)         
					);
				}
 
				function init() {
					$this->init_form_fields(); 
					$this->init_settings();
					$this->fee= $this->get_option( 'fee' );
					$this->fee_top= $this->get_option( 'fee_top' );					
					add_action( 'woocommerce_update_options_shipping_' . $this->id, array( $this, 'process_admin_options' ) );
					
				}
 
				/**
				 * calculate_shipping function.
				 *
				 * @access public
				 * @param mixed $package
				 * @return void
				 */
				public function calculate_shipping( $package = array() ) {
					$shipping_total=0;
					$shipping_total=$this->fee;
					
					$fee_top=$this->fee_top;
					$total = WC()->cart->cart_contents_total;					
					if($total>=$fee_top AND $fee_top<>0 AND $fee_top<>NULL)
					{$shipping_total=0;}
					
					$rate = array(
						'id' => $this->id,
						'label' => $this->title,
						'cost' => $shipping_total
					);
 
					// Register the rate
					$this->add_rate( $rate );
				}
                // O_C2CUPBe
                // $order_id:qs
                public function isSelectedSmilepayC2Cup($order_id)
                {
                 
                    if(!isset($order_id) || empty($order_id))
                    {
                        return false;
                    }
            
                    $order = new WC_Order($order_id);
          
                    if(!isset($order) || empty($order))
                        return false;
                    if( $order->has_shipping_method($this->id ))
                        return true;
                    else
                        return false;
                 }
 
			}
		}
	}

  
	add_action( 'woocommerce_shipping_init', 'smilepayc2cu_shipping_method_init' );
 
	function add_smilepayc2cu_shipping_method( $methods ) {
		$methods[] = 'WC_Smilepayc2cu_Shipping_Method';
		return $methods;
	}

 
	add_filter( 'woocommerce_shipping_methods', 'add_smilepayc2cu_shipping_method' );
}
function u2bcu($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ucu($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
