<?php
//include "smilepay_respond.php";
/**
 * Plugin Name: SmilePay_Credit 
 * Plugin URI: http://www.smilepay.net
 * Description: SmilePay Credit 
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
 * Version: 2.4.5
 */
add_action('plugins_loaded', 'SmilePaycredit_gateway_init', 0);
function SmilePaycredit_gateway_init() {
   if (!class_exists('WC_Payment_Gateway')) {
        return;
    }

    class WC_SmilePaycredit extends WC_Payment_Gateway {

        public $title;
        public $description;
        public $dcvc;
        public $Rvg2c;
        public $Order_OKmain;
        public $Verify_key;

        public function __construct() {
            $this->id = 'SmilePaycredit';
            $this->icon = apply_filters('woocommerce_SmilePaycredit_icon', plugins_url('log/paycredit.jpg', __FILE__));
            $this->has_fields = false;
            $this->method_title = __('SmilePaycredit', 'woocommerce');
            // Load the form fields.
            $this->init_form_fields();
            // Load the settings.
            $this->init_settings();
			
            // Define user set variables
            $this->title = $this->settings['title'];
            $this->description = $this->settings['description'];
            $this->dcvc = $this->settings['dcvc'];
            $this->Rvg2c =  $this->settings['Rvg2c'];
			$this->Verify_key = $this->settings['Verify_key'];			
			$this->Order_OKmain = $this->settings['Order_OKmain'];
            // Actions
            //add_action('init', array(&$this, 'check_SmilePaycredit_response'));
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
            add_action('woocommerce_thankyou_SmilePaycredit', array($this, 'thankyou_page')); 
        }
        /**
         * Initialise Gateway Settings Form Fields
         *
         * @access public
         * @return void
         */
        public function init_form_fields() {  //x]m
            $this->form_fields = array(
                'enabled' => array(
                    'title' => __(u2bcr("ҥ/"), 'woocommerce'),
                    'type' => 'checkbox',
                    'label' => __(u2bcr(' SmilePay uWd'), 'woocommerce'),
                    'default' => 'yes'
                ),
                'title' => array(
                    'title' => __(u2bcr('D'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('UȦbbɩܪIڤ覡D'), 'woocommerce'),
                    'default' => __(u2bcr('SmilePay uWd úO'), 'woocommerce')
                ),
                'description' => array(
                    'title' => __(u2bcr('Iڤ覡'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bcr('UȦbܥIڤ覡ɩܪФr'), 'woocommerce'),
                    'default' => __(u2bcr("SmilePay  uWd úO"), 'woocommerce')
                ),
                'dcvc' => array(
                    'title' => __(u2bcr('ӮaN'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('жJzSmilePayөN'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Rvg2c' => array(
                    'title' => __(u2bcr('ӮaѼƽX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('жJzSmilePayӮaѼƽX'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Verify_key' => array(
                    'title' => __(u2bcr('ӮaˬdX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bcr('жJzSmilePayӮaˬdXAˬdXӮaxuIAPIvAнƻsöKJW'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),				
				'Order_OKmain' => array(
                    'title' => __(u2bcr('q榨߫ܰT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bcr('q榨ܰT'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
            );
        }
        /**
         * Admin Panel Options
         * - Options for bits like 'title' and availability on a country-by-country basis
         *
         * @access public
         * @return void
         */
       public function get_SmilePaycredit_args($order) {
            global $woocommerce;

            $paymethod = 'credit';
            $order_id = $order->id;
			$post_status = $order->post_status;

            $SmilePaycredit_args = array(
                "dcvc" => $this->dcvc,
                'Rvg2c' => $this->Rvg2c,
				"dcvg" => $this->dcvg,
                "payment_type" => $paymethod,
				"post_status" => $post_status,
                "od_sob" => $order_id,
                'Verify_key' => $this->Verify_key,				
				'Order_OKmain' => $this->Order_OKmain,
				"amt" => round($order->get_total()),
            );
            $SmilePaycredit_args = apply_filters('woocommerce_SmilePaycredit_args', $SmilePaycredit_args);
            return $SmilePaycredit_args;
        }
		
       public function thankyou_page($order_id) {  //^ǰѼ  P   credit
			global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
            $order = new WC_Order($order_id);
			
			
			
			
			// $order = &new WC_Order($order_id);
			
			$SmilePaycredit_args = $this->get_SmilePaycredit_args($order);
			$order_status=$SmilePaycredit_args['post_status'];
			
		if($order_status=='wc-pending'||$order_status=='wc-failed')
		{
            //--ystart
			$shipping_method= $order->get_shipping_method();
			$getc2cu="N";
			if($_REQUEST['storeid']==''&&$_REQUEST['Classif']!='A')
			{
				//if($shipping_method==u2bcr("tRt7-11¨f"))
				
                include_once("smilepayc2cup.php");
                $smilepay_c2cupobj= new WC_Smilepayc2cu_Shipping_Method();
             
                //ˬdyO_ϥί¨f
				if( $smilepay_c2cupobj->isSelectedSmilepayC2Cup($order_id))
                {
					$URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
					$mappurl="https://emap.presco.com.tw/c2cemap.ashx?eshopid=870&servicetype=1&url=".urlencode($URL);
					header("Location: $mappurl"); 
					exit();	
				}
			}
			else
			{
				$c2c_storeaddress=$_REQUEST['storeaddress'];
				$c2c_storename=$_REQUEST['storename'];
				$c2c_storeid=$_REQUEST['storeid'];
				$getc2cu="Y";	
				$c2c_store=$c2c_storeid.'/'.$c2c_storename.'/'.$c2c_storeaddress;		
			}
			//--yend

			//qܦᵲ
			$order->update_status('on-hold');	
          	//}ҽuWd
			$URL = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			if($getc2cu=="Y")
			{$Address=$c2c_store;}
			else
			{$Address=$order->billing_address_1;}

			$pur_name = $order->billing_last_name . $order->billing_first_name;
			$c2c_store=$c2c_storeid.'/'.$c2c_storename.'/'.$c2c_storeaddress;
			$cardurl =	'https://ssl.smse.com.tw/ezpos/mtmk_utf.asp?'.
						'Dcvc=' . $SmilePaycredit_args['dcvc'] .
						'&Rvg2c=' .$SmilePaycredit_args['Rvg2c'] .
						'&Pur_name=' .urlencode($pur_name).
						'&Tel_number=' .urlencode($order->billing_phone).
						'&Address=' .urlencode($Address).
						'&Email=' .urlencode($order->billing_email).
						'&Data_id=' .$SmilePaycredit_args['od_sob'].
						'&od_sob=' . $SmilePaycredit_args['od_sob'].
						'&Amount=' . $SmilePaycredit_args['amt'].
						'&Deadline_date=' . $Deadline_date.
						'&Roturl_status=' . 'woook'.
						'&Remark=woocommerce';
			$post_strall=$cardurl.'&Pay_zg=1'.'&Roturl=' . urlencode($URL);
			header("Location: $post_strall"); 
			exit();	
		}		
		if($order_status=='wc-on-hold'&&$_REQUEST['Classif']=='A')
		{
			$A_Amount=$_REQUEST['Amount'];
			$A_Data_id=$_REQUEST['Data_id'];
			$A_Response_id=$_REQUEST['Response_id'];
			$A_Errdesc=$_REQUEST['Errdesc'];
			$A_Smseid=$_REQUEST['Smseid'];
			$A_date=$_REQUEST['Process_date'];
			$A_time=$_REQUEST['Process_time'];
			$A_Address=$_REQUEST['Address'];

            $title = b2ucr($this->title);
			if($A_Response_id=='1'&&$SmilePaycredit_args['amt']==$A_Amount)
			{
               
        		$order->reduce_order_stock();			
				$pay_ok="úO覡G<font color=red>$title</font><br>GG<font color=red>v\</font></br>vBG<font color=red>".
							$A_Amount."</font></br>ɶG<font color=red>".$A_date.$A_time."</font></br>";
				$order->add_order_note(u2bcr($pay_ok),"1");
				$ordertext="<h1>úOT</h1>úO覡G<font color=red>$title</font><br>GG<font color=red>v\</font></br>vBG<font color=red>".
							$A_Amount."</font></br>ɶG<font color=red>".$A_date." ".$A_time."</font></br>SmilePaylܽXG<font color=red>".$A_Smseid."</font>";
				$order->add_order_note(u2bcr($ordertext),"0");
				$order->update_status('processing');
				echo u2bcr($pay_ok);

				include_once("smilepayc2cup.php");
                $smilepay_c2cupobj= new WC_Smilepayc2cu_Shipping_Method();
             
                //ˬdyO_ϥί¨f
				if( $smilepay_c2cupobj->isSelectedSmilepayC2Cup($order_id))
				{
					include "smilepay_function_c2c.php";
                    $pur_name = $order->billing_last_name . $order->billing_first_name;
					$post_str = 'Dcvc=' . $SmilePaycredit_args['dcvc'] .
							'&Rvg2c=' . $SmilePaycredit_args['Rvg2c'] .
							'&Pur_name=' .$pur_name.
							'&Tel_number=' .$order->billing_phone.
							'&Email=' .$order->billing_email.
							'&Data_id=' . $SmilePaycredit_args['od_sob'].
							'&od_sob=' . $SmilePaycredit_args['od_sob'].
							'&Amount=' . $SmilePaycredit_args['amt'].
							'&Roturl_status=' . 'woook'.
							'&Verify_key=' . $SmilePaycredit_args['Verify_key'].
							'&Remark=woocommerce';
					$c2c_store=u2bcr($A_Address);
                    
					$scvurls=repeatc2c($c2c_store,$post_str,$SmilePaycredit_args['dcvc'],$SmilePaycredit_args['Verify_key']);
					$order->add_order_note(u2bcr($scvurls),"0");

                    $c2c_store_array= explode("/",$c2c_store); 
                    if(!empty($c2c_store_array) && count($c2c_store_array)==3)
                    {
                        $c2c_storeid=$c2c_store_array[0];
                        $c2c_storename=$c2c_store_array[1];
                        $c2c_storeaddress=$c2c_store_array[2];
                    }
                    else
                    {
                        $c2c_storeid="";
                        $c2c_storename="";
                        $c2c_storeaddress="";
                    }
                    
					$scvurls_1="7-11fG<font color=red>".b2ucr($c2c_storename . $c2c_storeid)."</font><br>";
                    $scvurls_1 .= "a}G<font color=red>".b2ucr($c2c_storeaddress)."</font><br>";
                    $scvurls_1 .= "fHmWG<font color=red>".b2ucr($pur_name)."</font><br>";
                    $scvurls_1 .= "fHqܡG<font color=red>".b2ucr($order->billing_phone)."</font><br>";

					$order->add_order_note(u2bcr($scvurls_1),"1");
                    echo u2bcr('<h1>fT</h1>' . $scvurls_1);
				}
				
				
				
			}
			else
			{
				$pay_err="úO覡G<font color=red>uWd</font><br>GG<font color=red>v</font></br>ɶG<font color=red>".
							$A_date.$A_time."</font></br>ѭ]G<font color=red>".$A_Errdesc."</font></br>";
				$order->add_order_note(u2bcr($pay_err),"1");
				$ordertext="úO覡G<font color=red>uWd</font><br>GG<font color=red>v</font></br>ɶG<font color=red>".
							$A_date.$A_time."</font></br>ѭ]G<font color=red>".$A_Errdesc."</font></br>SmilePaylܽXG<font color=red>".$A_Smseid."</font>";
				$order->add_order_note(u2bcr($ordertext),"0");
				$order->update_status('failed');
				echo u2bcr($pay_err);
			}
			echo "<br><br>".$SmilePaycredit_args['Order_OKmain'];
		}
}
        /**
         * Process the payment and return the result
         *
         * @access public
         * @param int $order_id
         * @return array
         */
        public function process_payment($order_id) {
			$order = new WC_Order( $order_id );
			//--ystart
			$shipping_method= $order->get_shipping_method();
            include_once('smilepayc2cp.php');
            include_once('smilepayc2cup.php');
            $smilepayc2cp_obj=new WC_Smilepayc2cp_Shipping_Method();
            $smilepayc2cup_obj=new WC_Smilepayc2cu_Shipping_Method();
            if($smilepayc2cup_obj->isSelectedSmilepayC2Cup($order_id))
			//if($shipping_method==u2bcr("tRt7-11¨f"))
			{
				$username=$order->billing_first_name.$order->billing_last_name;
				if(substr($order->billing_phone,0,2)!="09"||mb_strlen($order->billing_phone)!=10||mb_strlen( $username, "utf-8")>5){
          wc_add_notice( __(u2bcr("<br>qܮ榡~Ad09XX123456(@10X)C<br>O̩mWiWL5ӦrCЦAT{C<br>"), 'woothemes') . $error_message, 'error' );
          return;
					exit;
				}
			}
            if($smilepayc2cp_obj->isSelectedSmilepayC2Cp($order_id))
			//if($shipping_method==u2bcr("tRt7-11fI"))
			{
          wc_add_notice( __(u2bcr("<br><font color='red'>te覡ܿ~Aiܦte覡</font><br>"), 'woothemes') . $error_message, 'error' );
          return;
          exit;
        }
			//--yend
			WC()->cart->empty_cart();
			return array(
				'result' 	=> 'success',
				'redirect'	=> $this->get_return_url( $order )
			);
        }

        /**
         * Payment form on checkout page
         *
         * @access public
         * @return void
         */
    }
    /**
     * Add the gateway to WooCommerce
     *
     * @access public
     * @param array $methods
     * @package		WooCommerce/Classes/Payment
     * @return array
     */
    function add_SmilePaycredit_gateway($methods) {
        $methods[] = 'WC_SmilePaycredit';
        return $methods;
    }

    add_filter('woocommerce_payment_gateways', 'add_SmilePaycredit_gateway');
}
function u2bcr($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ucr($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
?>